# SPDX-FileCopyrightText: Mintlab B.V.
#
# SPDX-License-Identifier: EUPL-1.2

import pytest
import random
from datetime import datetime, timezone
from typing import Any, Callable, Literal
from typing_extensions import TypedDict
from unittest import mock
from uuid import UUID, uuid4
from zsnl_domains.case_management import entities

# Goal of this test file is to provide functions to create entities containing
# default values so they can be easily used within unittests.


CaseDbRowFixture = Callable[
    [UUID | None, datetime | None, datetime | None, datetime | None], list[Any]
]


class ContactDetailsPersonDbRow(TypedDict):
    pass


class ContactDetailsOrganizationDbRow(TypedDict):
    pass


class EmployeeAddressPart(TypedDict):
    id: int
    parameter: Literal[
        "customer_info_postcode",
        "customer_info_straatnaam",
        "customer_info_huisnummer",
    ]


class ContactDetailsEmployeeDbRow(TypedDict):
    id: int
    uuid: UUID
    subject_type: Literal["employee"]
    properties: dict[str, Any]
    settings: dict[str, Any]
    username: str
    role_ids: list[int]
    group_ids: list[int]
    nobody: bool
    system: bool
    related_custom_object_id: int | None
    employee_address: list[EmployeeAddressPart]


class CaseContactDbRow(TypedDict):
    uuid: UUID
    type: Literal["medewerker", "bedrijf", "natuurlijk_persoon"]
    role: str | None
    magic_string_prefix: str | None

    contact_details: (
        ContactDetailsPersonDbRow
        | ContactDetailsOrganizationDbRow
        | ContactDetailsEmployeeDbRow
    )


@pytest.fixture
def case_db_rows() -> CaseDbRowFixture:
    def _loader(
        case_id: int | None = None,
        case_uuid: UUID | None = None,
        last_modified: datetime | None = None,
        created: datetime | None = None,
        registered: datetime | None = None,
        contacts: list[CaseContactDbRow] | None = None,
        case_type_version_uuid: UUID | None = None,
        case_type_node_id: int | None = None,
        notification_settings: dict[str, bool] | None = None,
    ):
        if case_uuid is None:
            case_uuid = uuid4()

        if contacts is None:
            contacts = [
                {
                    "type": "medewerker",
                    "uuid": uuid4(),
                    "role": "Aanvrager",
                    "magic_string_prefix": "aanvrager",
                    "contact_details": {
                        "id": random.randint(1, 100),
                        "uuid": uuid4(),
                        "subject_type": "employee",
                        "properties": {},
                        "settings": {},
                        "username": "piet",
                        "role_ids": [],
                        "group_ids": [],
                        "nobody": False,
                        "system": False,
                        "related_custom_object_id": None,
                        "employee_address": [],
                    },
                },
                {
                    "type": "medewerker",
                    "uuid": uuid4(),
                    "role": "Behandelaar",
                    "magic_string_prefix": "behandelaar",
                    "contact_details": {
                        "id": random.randint(1, 100),
                        "uuid": uuid4(),
                        "subject_type": "employee",
                        "properties": {},
                        "settings": {},
                        "username": "piet",
                        "role_ids": [],
                        "group_ids": [],
                        "nobody": False,
                        "system": False,
                        "related_custom_object_id": None,
                        "employee_address": [],
                    },
                },
                {
                    "type": "medewerker",
                    "uuid": uuid4(),
                    "role": "Coordinator",
                    "magic_string_prefix": "coordinator",
                    "contact_details": {
                        "id": random.randint(1, 100),
                        "uuid": uuid4(),
                        "subject_type": "employee",
                        "properties": {},
                        "settings": {},
                        "username": "piet",
                        "role_ids": [],
                        "group_ids": [],
                        "nobody": False,
                        "system": False,
                        "related_custom_object_id": None,
                        "employee_address": [],
                    },
                },
            ]

        contact_rows: list[Any] = [
            # First: _get_roles_query (related contacts + their roles)
            tuple(
                [
                    [
                        {
                            "uuid": c["uuid"],
                            "type": c["type"],
                            "role": c["role"],
                            "magic_string_prefix": c["magic_string_prefix"],
                        }
                        for c in contacts
                    ]
                ]
            )
        ]
        for contact in contacts:
            # Second: a "person", "organization" or "employee" row for each contact
            contact_rows.append(tuple([contact["contact_details"]]))

        now = datetime.now(tz=timezone.utc)

        case = mock.Mock(
            **{
                "id": case_id or random.randint(1, 1000),
                "uuid": case_uuid or uuid4(),
                "onderwerp": "test",
                "route_ou": "1",
                "route_role": "role_id",
                "vernietigingsdatum": None,
                "archival_state": None,
                "status": "new",
                "contactkanaal": "post",
                "created": created or now,
                "registratiedatum": registered or now,
                "streefafhandeldatum": None,
                "afhandeldatum": None,
                "stalled_until": None,
                "milestone": 1,
                "last_modified": last_modified or now,
                "behandelaar_gm_id": 1,
                "coordinator_gm_id": 1,
                "aanvrager": 200,
                "aanvraag_trigger": "extern",
                "onderwerp_extern": "test summary",
                "resultaat": "test",
                "resultaat_id": 1,
                "result_uuid": uuid4(),
                "payment_amount": "100",
                "payment_status": "success",
                "confidentiality": "public",
                "behandelaar": 100,
                "coordinator": None,
                "urgency": "No",
                "preset_client": "No",
                "prefix": "1",
                "active_selection_list": "test list",
                "case_status": {
                    "id": 348,
                    "zaaktype_node_id": 147,
                    "status": 1,
                    "status_type": None,
                    "naam": "Geregistreerd",
                    "created": now,
                    "last_modified": now,
                    "ou_id": 1,
                    "role_id": 12,
                    "checklist": None,
                    "fase": "Registreren",
                    "role_set": None,
                },
                "case_meta": {
                    "opschorten": None,
                    "afhandeling": None,
                    "stalled_since": None,
                },
                "case_role": {
                    "uuid": str(uuid4()),
                    "name": "Behandelaar",
                    "description": "Systeemrol: Behandelaar",
                    "parent_uuid": str(uuid4()),
                    "parent_name": "Development",
                },
                "type_of_archiving": "Bewaren (B)",
                "period_of_preservation": "4 weken",
                "result_description": "closing the case",
                "result_explanation": "closing the case",
                "result_selection_list_number": "10",
                "result_process_type_number": "11",
                "result_process_type_name": "test-process-type",
                "result_process_type_description": "This is test process type",
                "result_process_type_explanation": "This is test process type",
                "result_process_type_generic": "Generiek",
                "result_origin": "Systeemanalyse",
                "result_process_term": "A",
                "aggregation_scope": "Dossier",
                "number_parent": None,
                "number_master": 737,
                "number_previous": None,
                "price": 100,
                "result_process_type_object": "Procestype-object",
                "custom_fields": [],
                "file_custom_fields": [],
                "case_actions": {},
                "case_department": {
                    "uuid": str(uuid4()),
                    "name": "Backoffice",
                    "description": "Default backoffice",
                    "parent_uuid": str(uuid4()),
                    "parent_name": "Development",
                },
                "case_subjects": [],
                "destructable": False,
                "suspension_rationale": None,
                "premature_completion_rationale": None,
                "days_left": 10,
                "lead_time_real": None,
                "progress_days": 10,
                "user_is_admin": False,
                "authorizations": ["read", "manage"],
                "user_is_requestor": False,
                "user_is_assignee": False,
                "user_is_coordinator": False,
            }
        )

        case_type = dict(
            id=str(case_type_version_uuid or uuid4()),
            uuid=case_type_version_uuid or uuid4(),
            case_type_uuid=uuid4(),
            version=random.randint(1, 10),
            active=True,
            name="Test Case Type",
            created=now,
            deleted=None,
            last_modified=now,
            initiator_source="internextern",
            identification="test",
            is_public=False,
            tags="",
            description="Description",
            enable_allocation_on_form=1,
            allow_reuse_casedata=None,
            enable_subject_relations_on_form=None,
            open_case_on_create=1,
            require_email_on_webform=False,
            require_mobilenumber_on_webform=False,
            require_phonenumber_on_webform=False,
            show_contact_info=False,
            enable_online_payment=False,
            enable_webform=False,
            disable_pip_for_requestor=False,
            use_requestor_address_for_correspondence=False,
            properties={
                "verlenging_mogelijk": "Nee",
                "pdc_tarief_balie": "",
                "verantwoordelijke": "",
                "archiefclassicatiecode": "",
                "case_location_check": None,
                "notify_on_new_document": None,
                "no_captcha": None,
                "pdc_tarief_post": "",
                "verlengingstermijn": "",
                "delayed": None,
                "bag": "Nee",
                "gdpr": {
                    "enabled": "Nee",
                    "process_foreign_country_reason": "",
                    "source_personal": {
                        "partner": None,
                        "sender": None,
                        "registration": None,
                        "public_source": None,
                    },
                    "processing_legal_reason": "",
                    "processing_legal": "Toestemming",
                    "process_foreign_country": "Nee",
                    "processing_type": "Delen",
                    "personal": {
                        "personal_id_number": None,
                        "basic_details": None,
                        "sexual_identity": None,
                        "income": None,
                        "criminal_record": None,
                        "offspring": None,
                        "race_or_ethniticy": None,
                        "religion": None,
                        "health": None,
                        "membership_union": None,
                        "genetic_or_biometric_data": None,
                        "political_views": None,
                    },
                },
                "notify_on_exceed_term": None,
                "beroep_mogelijk": "Nee",
                "notify_on_new_message": None,
                "opschorten_mogelijk": "Nee",
                "wkpb": "Nee",
                "default_directories": [],
                "pdc_tarief_behandelaar": "",
                "allow_external_task_assignment": None,
                "verantwoordingsrelatie": "",
                "notify_on_label_change": None,
                "offline_betaling": None,
                "api_can_transition": None,
                "pdc_tarief_email": "",
                "pip_view_message": "Ook kunt u op elk moment van de dag de voortgang en inhoud inzien via de persoonlijke internetpagina.",
                "notify_on_allocate_case": None,
                "notify_on_new_case": None,
                "notify_on_task_change": None,
                "aanleiding": "",
                "lex_silencio_positivo": "Nee",
                "publicatie": "Nee",
                "publicatietekst": "",
                "e_formulier": "",
                "vertrouwelijkheidsaanduiding": "-",
                "lock_registration_phase": None,
                "case_location_message": "",
                "notify_on_subject_change": None,
                "confidentiality": None,
                "queue_coworker_changes": None,
                "doel": "",
                "public_confirmation_message": "Bedankt voor het [[case.casetype.initiator_type]] van een <strong>[[case.casetype.name]]</strong>. Uw registratie is bij ons bekend onder <strong>zaaknummer [[case.number]]</strong>. Wij verzoeken u om bij verdere communicatie dit zaaknummer te gebruiken. De behandeling van deze zaak zal spoedig plaatsvinden.",
                "pdc_tarief_telefoon": "",
                "lokale_grondslag": "asd",
                "notify_on_phase_transition": None,
                "wet_dwangsom": "Nee",
                "verdagingstermijn": "",
                "preset_owner_identifier": "",
                "public_confirmation_title": "Uw zaak is geregistreerd",
            },
            initiator_type="aangaan",
            webform_amount="",
            legal_basis="blah",
            process_description="",
            case_summary="",
            case_public_summary="",
            terms={
                "lead_time_legal": {"type": "kalenderdagen", "value": 100},
                "lead_time_service": {"type": "kalenderdagen", "value": 100},
            },
            catalog_folder={
                "uuid": uuid4(),
                "name": "Some folder",
            },
            phases=[
                {
                    "name": "Phase1",
                    "milestone": 2,
                    "phase": 1,
                }
            ],
            requestor={
                "type_of_requestors": [
                    "niet_natuurlijk_persoon",
                    "natuurlijk_persoon",
                    "medewerker",
                ],
                "use_for_correspondence": False,
            },
            preset_requestor=None,
            preset_assignee={},
            results=[
                {
                    "uuid": uuid4(),
                    "name": "Aangegaan",
                    "result": "aangegaan",
                    "trigger_archival": True,
                    "preservation_term_label": "4 weken",
                    "preservation_term_unit": "week",
                    "preservation_term_unit_amount": 4,
                }
            ],
        )

        mock_case_type_node_id = mock.Mock()
        mock_case_type_node_id.id = case_type_node_id or random.randint(
            200, 299
        )
        return [
            case,
            *contact_rows,
            [case_type_version_uuid or uuid4()],
            mock_case_type_node_id,
            [case_type],
            True,
            None,  # Case location
        ]

    return _loader


@pytest.fixture
def test_case() -> entities.Case:
    case_entity_json = {
        "entity_type": "case",
        "entity_meta_summary": "Description for this case Ellermanstraat 23, 1114AK Amsterdam-Duivendrecht with a prefix",
        "entity_relationships": [
            "coordinator",
            "assignee",
            "requestor",
            "case_type",
            "case_type_version",
            "related_contacts",
        ],
        "entity_meta__fields": [
            "entity_meta_summary",
            "entity_meta_authorizations",
        ],
        "entity_id__fields": ["uuid"],
        "entity_changelog": [],
        "entity_data": {},
        "entity_meta_authorizations": ["write", "read", "manage", "search"],
        "id": 2,
        "number": 2,
        "department": {
            "entity_type": "department",
            "entity_id": None,
            "entity_meta_summary": None,
            "entity_relationships": ["parent"],
            "entity_meta__fields": ["entity_meta_summary"],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "uuid": "923996fc-f8f8-4745-9886-a8b00bce1bbe",
            "name": "Backoffice",
            "description": "Default backoffice",
            "parent": {
                "entity_type": "department",
                "entity_id": None,
                "entity_meta_summary": None,
                "entity_relationships": [],
                "entity_meta__fields": ["entity_meta_summary"],
                "entity_id__fields": ["uuid"],
                "entity_changelog": [],
                "entity_data": {},
                "uuid": "432555e5-2a37-4380-8571-5f51df8c07ab",
                "name": "Development",
            },
        },
        "role": {
            "entity_type": "role",
            "entity_id": None,
            "entity_meta_summary": None,
            "entity_relationships": ["parent"],
            "entity_meta__fields": ["entity_meta_summary"],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "uuid": "8b07fe5d-7685-4a58-b851-3d9692f90c62",
            "name": "Behandelaar",
            "description": "Systeemrol: Behandelaar",
            "parent": {
                "entity_type": "department",
                "entity_id": None,
                "entity_meta_summary": None,
                "entity_relationships": [],
                "entity_meta__fields": ["entity_meta_summary"],
                "entity_id__fields": ["uuid"],
                "entity_changelog": [],
                "entity_data": {},
                "uuid": "432555e5-2a37-4380-8571-5f51df8c07ab",
                "name": "Development",
            },
        },
        "destruction_date": None,
        "destruction_reason": None,
        "phase": {"label": "Afhandelen", "milestone_label": "Afgehandeld"},
        "result": None,
        "archival_state": None,
        "public_summary": "Extra description for this case Ellermanstraat 23, 1114AK Amsterdam-Duivendrecht with a prefix",
        "status": "open",
        "created_date": "2022-12-21",
        "registration_date": "2022-12-21",
        "target_completion_date": "2023-12-06",
        "completion_date": None,
        "stalled_until_date": None,
        "milestone": 1,
        "suspension_reason": None,
        "completion": None,
        "stalled_since_date": None,
        "last_modified_date": "2022-12-21",
        "coordinator": {
            "entity_type": "employee",
            "entity_id": "7145766b-472c-4316-9634-6470ea51c4c9",
            "entity_meta_summary": None,
            "entity_relationships": [],
            "entity_meta__fields": [
                "entity_meta_summary",
                "magic_string_prefix",
                "role",
            ],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "id": "1",
            "uuid": "7145766b-472c-4316-9634-6470ea51c4c9",
            "role": "Coordinator",
            "name": "Ad Mïn",
            "type": "employee",
            "surname": "Mïn",
            "magic_string_prefix": "coordinator",
            "family_name": "Mïn",
            "full_name": "Ad Mïn",
            "first_names": "Ad",
            "initials": "A.",
            "last_name": "Mïn",
            "title": None,
            "unique_name": "betrokkene-medewerker-1",
            "subject_type": "medewerker",
            "status": "Actief",
            "street": None,
            "residence_street": None,
            "zipcode": None,
            "residence_zipcode": None,
            "house_number": None,
            "residence_house_number": None,
            "phone_number": "0612345678",
            "email": "devNone@zaaksysteem.nl",
            "department": "Backoffice",
            "correspondence_zipcode": None,
            "correspondence_street": None,
            "properties": {
                "givenname": "Ad",
                "cn": "admin",
                "mail": "devNone@zaaksysteem.nl",
                "displayname": "Ad Mïn",
                "sn": "Mïn",
                "default_dashboard": 1,
                "telephonenumber": "0612345678",
                "initials": "A.",
            },
        },
        "assignee": {
            "entity_type": "employee",
            "entity_id": "7145766b-472c-4316-9634-6470ea51c4c9",
            "entity_meta_summary": None,
            "entity_relationships": [],
            "entity_meta__fields": [
                "entity_meta_summary",
                "magic_string_prefix",
                "role",
            ],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "id": "1",
            "uuid": "7145766b-472c-4316-9634-6470ea51c4c9",
            "role": "Behandelaar",
            "name": "Ad Mïn",
            "type": "employee",
            "surname": "Mïn",
            "magic_string_prefix": "behandelaar",
            "family_name": "Mïn",
            "full_name": "Ad Mïn",
            "first_names": "Ad",
            "initials": "A.",
            "last_name": "Mïn",
            "title": None,
            "unique_name": "betrokkene-medewerker-1",
            "subject_type": "medewerker",
            "status": "Actief",
            "street": None,
            "residence_street": None,
            "zipcode": None,
            "residence_zipcode": None,
            "house_number": None,
            "residence_house_number": None,
            "phone_number": "0612345678",
            "email": "devNone@zaaksysteem.nl",
            "department": "Backoffice",
            "correspondence_zipcode": None,
            "correspondence_street": None,
            "properties": {
                "givenname": "Ad",
                "cn": "admin",
                "mail": "devNone@zaaksysteem.nl",
                "displayname": "Ad Mïn",
                "sn": "Mïn",
                "default_dashboard": 1,
                "telephonenumber": "0612345678",
                "initials": "A.",
            },
        },
        "requestor": {
            "entity_type": "employee",
            "entity_id": "7145766b-472c-4316-9634-6470ea51c4c9",
            "entity_meta_summary": None,
            "entity_relationships": [],
            "entity_meta__fields": [
                "entity_meta_summary",
                "magic_string_prefix",
                "role",
            ],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "id": "1",
            "uuid": "7145766b-472c-4316-9634-6470ea51c4c9",
            "role": "Aanvrager",
            "name": "Ad Mïn",
            "type": "employee",
            "surname": "Mïn",
            "magic_string_prefix": "aanvrager",
            "family_name": "Mïn",
            "full_name": "Ad Mïn",
            "first_names": "Ad",
            "initials": "A.",
            "last_name": "Mïn",
            "title": None,
            "unique_name": "betrokkene-medewerker-1",
            "subject_type": "medewerker",
            "status": "Actief",
            "street": None,
            "residence_street": None,
            "zipcode": None,
            "residence_zipcode": None,
            "house_number": None,
            "residence_house_number": None,
            "phone_number": "0612345678",
            "email": "devNone@zaaksysteem.nl",
            "department": "Backoffice",
            "correspondence_zipcode": None,
            "correspondence_street": None,
            "properties": {
                "givenname": "Ad",
                "cn": "admin",
                "mail": "devNone@zaaksysteem.nl",
                "displayname": "Ad Mïn",
                "sn": "Mïn",
                "default_dashboard": 1,
                "telephonenumber": "0612345678",
                "initials": "A.",
            },
        },
        "subject": None,
        "subject_extern": None,
        "request_trigger": "extern",
        "contact_channel": "behandelaar",
        "resume_reason": None,
        "summary": None,
        "payment": {"amount": None, "status": None},
        "confidentiality": "public",
        "meta": {
            "id": None,
            "completion": None,
            "suspension_reason": None,
            "stalled_since_date": None,
        },
        "case_actions": {
            "1": {
                "allocation": [
                    {
                        "data": {
                            "original_role_id": 12,
                            "description": "Toewijzing",
                            "ou_id": 1,
                            "role_id": 12,
                            "role_set": None,
                            "original_ou_id": 1,
                        },
                        "automatic": None,
                    }
                ]
            }
        },
        "enqueued_subcases_data": None,
        "queue_ids": None,
        "custom_fields": {
            "kenmerk_locatiemetkaart": {
                "type": "geolatlon",
                "value": "52.326964736309215,4.929905533654112",
            },
            "kenmerk_adressv2": {
                "type": "address_v2",
                "value": {
                    "geojson": {
                        "type": "FeatureCollection",
                        "features": [
                            {
                                "geometry": {
                                    "coordinates": [4.93007286, 52.32687476],
                                    "type": "Point",
                                },
                                "properties": {},
                                "type": "Feature",
                            }
                        ],
                    },
                    "bag": {
                        "type": "nummeraanduiding",
                        "id": "0437200000001750",
                    },
                    "address": {
                        "full": "Ellermanstraat 23, 1114AK Amsterdam-Duivendrecht"
                    },
                },
            },
            "kenmerk_straat": {
                "type": "bag_openbareruimte",
                "value": "Welbergweg, Hengelo",
            },
            "kenmerk_datum": {"type": "date", "value": "2020-02-29"},
            "kenmerk_email": {"type": "email", "value": "test@example.com"},
            "kenmerk_geolocatie": {
                "type": "geojson",
                "value": {
                    "type": "FeatureCollection",
                    "features": [
                        {
                            "type": "Feature",
                            "properties": {},
                            "geometry": {
                                "coordinates": [
                                    [
                                        [5.471831, 51.452442],
                                        [5.471831, 51.452639],
                                        [5.472598, 51.452639],
                                        [5.472598, 51.452442],
                                        [5.471831, 51.452442],
                                    ]
                                ],
                                "type": "Polygon",
                            },
                        }
                    ],
                },
            },
            "kenmerk_enkelvoudigekeuze": {
                "type": "option",
                "value": "option 1",
            },
            "kenmerk_meervoudigekeuze": {
                "type": "checkbox",
                "value": ["choice_b"],
            },
            "kenmerk_numeriek": {"type": "numeric", "value": "1234567890"},
            "kenmerk_richtext": {
                "type": "richtext",
                "value": "<p>Content <s>with </s><strong>some </strong>markup</p><h1>Looks great!</h1>",
            },
            "kenmerk_keuzelijst": {"type": "select", "value": ["eee"]},
            "kenmerk_tekstveld": {
                "type": "text",
                "value": "tekstveld content",
            },
            "kenmerk_tekstveld_multivalue": {
                "type": "text",
                "value": ["text one", "text two", "text three"],
            },
            "kenmerk_tekstveld_multivalue_bad": {
                "type": "text",
                "value": [],
            },
            "kenmerk_webadress": {
                "type": "url",
                "value": "https://example.com",
            },
            "kenmerk_valuta": {"type": "valuta", "value": "900.12"},
            "kenmerk_document": {
                "type": "file",
                "value": [
                    {
                        "md5": "473fdd0d880a43c21b7778d3487215",
                        "size": 12,
                        "uuid": "61afb2d8-a54e-4f3f-b1b0-949736e7104d",
                        "filename": "test_document.txt",
                        "mimetype": "text/plain",
                        "is_archivable": True,
                        "original_name": "test_document.txt",
                        "thumbnail_uuid": None,
                    }
                ],
            },
        },
        "subjects": [],
        "alternative_case_number": "2",
        "urgency": None,
        "preset_client": False,
        "contact_information": None,
        "send_email_to_assignee": None,
        "assignee_email_queue_id": None,
        "case_type_version": {
            "entity_type": "case_type_version",
            "entity_id": "3e9ca460-57bf-4c81-a34d-ae80ce621122",
            "entity_meta_summary": None,
            "entity_relationships": [
                "catalog_folder",
                "preset_assignee",
                "preset_requestor",
            ],
            "entity_meta__fields": ["entity_meta_summary"],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "id": "3e9ca460-57bf-4c81-a34d-ae80ce621122",
            "uuid": "3e9ca460-57bf-4c81-a34d-ae80ce621122",
            "case_type_uuid": "aaef48d3-98f4-4e66-ade8-af0409137e2f",
            "version": 8,
            "name": "Test_casetype",
            "description": "",
            "identification": "Test_casetype identification",
            "tags": "",
            "case_summary": "Description for this case [[case.case_location.nummeraanduiding]] with a prefix",
            "case_public_summary": "Extra description for this case [[case.case_location.nummeraanduiding]] with a prefix",
            "active": True,
            "phases": [
                {
                    "name": "Geregistreerd",
                    "milestone": 1,
                    "phase": "Registreren",
                    "allocation": {
                        "department": {
                            "entity_type": "department",
                            "entity_id": None,
                            "entity_meta_summary": None,
                            "entity_relationships": ["parent"],
                            "entity_meta__fields": ["entity_meta_summary"],
                            "entity_id__fields": ["uuid"],
                            "entity_changelog": [],
                            "entity_data": {},
                            "uuid": "432555e5-2a37-4380-8571-5f51df8c07ab",
                            "name": "Development",
                            "description": "",
                            "parent": None,
                        },
                        "role": {
                            "entity_type": "role",
                            "entity_id": None,
                            "entity_meta_summary": None,
                            "entity_relationships": ["parent"],
                            "entity_meta__fields": ["entity_meta_summary"],
                            "entity_id__fields": ["uuid"],
                            "entity_changelog": [],
                            "entity_data": {},
                            "uuid": "8b07fe5d-7685-4a58-b851-3d9692f90c62",
                            "name": "Behandelaar",
                            "description": "",
                            "parent": None,
                        },
                        "role_set": None,
                    },
                    "cases": [],
                    "custom_fields": [
                        {
                            "name": "kenmerk_tekstveld",
                            "uuid": "31c5f664-6755-42c4-8a7d-70e573b060af",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_tekstveld",
                            "field_type": "text",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        }
                    ],
                    "documents": [],
                    "emails": [],
                    "subjects": [],
                    "checklist_items": [],
                    "rules": [],
                },
                {
                    "name": "Afgehandeld",
                    "milestone": 2,
                    "phase": "Afhandelen",
                    "allocation": None,
                    "cases": [],
                    "custom_fields": [
                        {
                            "name": "kenmerk_adressv2",
                            "uuid": "6e74fca9-5ccf-4fe5-8677-62c026f911ee",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_adressv2",
                            "field_type": "address_v2",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_datum",
                            "uuid": "fd823c11-89f1-495b-a94a-969b2675de12",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_datum",
                            "field_type": "date",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_document",
                            "uuid": "1b21b52d-c9c0-4786-8d47-bd146a30c998",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_document",
                            "field_type": "file",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_email",
                            "uuid": "d2b570a3-1575-40c2-bed4-528d22c7af6f",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_email",
                            "field_type": "email",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_enkelvoudigekeuze",
                            "uuid": "eb85ac94-c5b3-4ee5-a6cf-5ceec1f01114",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_enkelvoudigekeuze",
                            "field_type": "option",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [
                                "option 1",
                                "option 2",
                                "option 3",
                                "option 4",
                            ],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_geolocatie",
                            "uuid": "a8c331ee-e499-4f95-a8c8-d5859dc1cab6",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_geolocatie",
                            "field_type": "geojson",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_keuzelijst",
                            "uuid": "36643ade-ec45-4107-8a0e-ba5167c825a1",
                            "public_name": "",
                            "title": None,
                            "is_multiple": True,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_keuzelijst",
                            "field_type": "select",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [
                                "aaa",
                                "bbb",
                                "ccc",
                                "ddd",
                                "eee",
                                "fff",
                                "ggg",
                            ],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_locatiemetkaart",
                            "uuid": "85465bec-febc-4887-a6cf-b914ea1ac5c9",
                            "public_name": "",
                            "title": "",
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": "",
                            "external_description": "",
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_locatiemetkaart",
                            "field_type": "geolatlon",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_meervoudigekeuze",
                            "uuid": "ad6fe8ef-b612-4fba-b32c-14becfa49235",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_meervoudigekeuze",
                            "field_type": "checkbox",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [
                                "choice_a",
                                "choice_b",
                                "choice_c",
                                "choice_d",
                                "choice_e",
                            ],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_numeriek",
                            "uuid": "b8adb7d8-6e5c-46a6-9283-d8ce104e5dd0",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_numeriek",
                            "field_type": "numeric",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_richtext",
                            "uuid": "14a43fd6-2645-49bd-bfc2-707168c98456",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_richtext",
                            "field_type": "richtext",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_straat",
                            "uuid": "0363000e-9c8a-475a-a7eb-78140a2ba868",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_straat",
                            "field_type": "bag_openbareruimte",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_valuta",
                            "uuid": "e44d0fa1-1ffe-4d9d-9828-6b555a0ab453",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_valuta",
                            "field_type": "valuta",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_webadress",
                            "uuid": "32f03033-832a-4f4b-b88c-7e418485f0a4",
                            "public_name": "",
                            "title": None,
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": None,
                            "external_description": None,
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_webadress",
                            "field_type": "url",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                        {
                            "name": "kenmerk_tekstveld",
                            "uuid": "31c5f664-6755-42c4-8a7d-70e573b060af",
                            "public_name": "",
                            "title": "",
                            "is_multiple": False,
                            "title_multiple": None,
                            "description": "",
                            "external_description": "",
                            "is_required": False,
                            "requestor_can_change_from_pip": False,
                            "is_hidden_field": False,
                            "enable_skip_of_queue": False,
                            "sensitive_data": False,
                            "field_magic_string": "kenmerk_tekstveld",
                            "field_type": "text",
                            "default_value": "",
                            "referential": False,
                            "publish_on": [{"name": "pip"}, {"name": "web"}],
                            "edit_authorizations": [],
                            "field_options": [],
                            "date_field_limit": {"start": None, "end": None},
                            "relationship_uuid": None,
                            "relationship_type": None,
                            "relationship_name": None,
                            "relationship_subject_role": "",
                        },
                    ],
                    "documents": [],
                    "emails": [],
                    "subjects": [],
                    "checklist_items": [],
                    "rules": [],
                },
            ],
            "requestor": {
                "type_of_requestors": [
                    "natuurlijk_persoon_na",
                    "natuurlijk_persoon",
                    "medewerker",
                    "niet_natuurlijk_persoon",
                ],
                "use_for_correspondence": False,
            },
            "settings": {
                "allow_reuse_casedata": None,
                "enable_webform": None,
                "enable_online_payment": None,
                "enable_manual_payment": None,
                "require_email_on_webform": False,
                "require_phonenumber_on_webform": False,
                "require_mobilenumber_on_webform": False,
                "disable_captcha_for_predefined_requestor": None,
                "show_confidentiality": None,
                "show_contact_info": False,
                "enable_subject_relations_on_form": None,
                "open_case_on_create": True,
                "enable_allocation_on_form": True,
                "disable_pip_for_requestor": False,
                "list_of_default_folders": [],
                "lock_registration_phase": None,
                "enable_queue_for_changes_from_other_subjects": None,
                "check_acl_on_allocation": None,
                "api_can_transition": None,
                "is_public": False,
                "text_confirmation_message_title": "Uw zaak is geregistreerd",
                "text_public_confirmation_message": "Bedankt voor het [[case.casetype.initiator_type]] van een <strong>[[case.casetype.name]]</strong>. Uw registratie is bij ons bekend onder <strong>zaaknummer [[case.number]]</strong>. Wij verzoeken u om bij verdere communicatie dit zaaknummer te gebruiken. De behandeling van deze zaak zal spoedig plaatsvinden.",
                "payment": {
                    "assignee": {"amount": ""},
                    "frontdesk": {"amount": ""},
                    "phone": {"amount": ""},
                    "mail": {"amount": ""},
                    "webform": {"amount": ""},
                    "post": {"amount": ""},
                },
            },
            "terms": {
                "lead_time_legal": {"type": "kalenderdagen", "value": "365"},
                "lead_time_service": {"type": "kalenderdagen", "value": "350"},
            },
            "metadata": {
                "legal_basis": "wettelijke grondslag content",
                "process_description": "",
                "may_postpone": "Nee",
                "may_extend": "Nee",
                "extension_period": "",
                "adjourn_period": "",
                "e_webform": "",
                "motivation": "",
                "purpose": "",
                "archive_classification_code": "",
                "designation_of_confidentiality": "-",
                "responsible_subject": "",
                "responsible_relationship": "",
                "possibility_for_objection_and_appeal": "Nee",
                "publication": "Nee",
                "publication_text": "",
                "bag": "Nee",
                "lex_silencio_positivo": "Nee",
                "penalty_law": "Nee",
                "wkpb_applies": "Nee",
                "local_basis": "",
            },
            "case_type_results": [
                {
                    "entity_type": "case_type_result",
                    "entity_id": None,
                    "entity_meta_summary": None,
                    "entity_relationships": [],
                    "entity_meta__fields": ["entity_meta_summary"],
                    "entity_id__fields": [],
                    "entity_changelog": [],
                    "entity_data": {},
                    "uuid": "2b7d876c-cc7c-4a55-8d1a-37f4a61a4b67",
                    "name": "Akkoord",
                    "result": "akkoord",
                    "trigger_archival": True,
                    "preservation_term_label": "4 weken",
                    "preservation_term_unit": "week",
                    "preservation_term_unit_amount": 4,
                }
            ],
            "initiator_source": "internextern",
            "initiator_type": "aangaan",
            "is_eligible_for_case_creation": True,
            "created": "2022-12-21T09:19:11.056801",
            "last_modified": "2022-12-21T09:19:11.056801",
            "deleted": None,
            "catalog_folder": {
                "entity_type": "folder",
                "entity_id": "e8cca6f7-8d55-4e24-96e6-18cd0417997c",
                "entity_meta_summary": "test_casetype",
                "entity_relationships": [],
                "entity_meta__fields": ["entity_meta_summary"],
                "entity_id__fields": ["uuid"],
                "entity_changelog": [],
                "entity_data": {},
                "uuid": "e8cca6f7-8d55-4e24-96e6-18cd0417997c",
                "name": "test_casetype",
            },
            "preset_assignee": None,
            "preset_requestor": None,
            "_event_service": None,
        },
        "case_type": {
            "entity_type": "case_type",
            "entity_id": "aaef48d3-98f4-4e66-ade8-af0409137e2f",
            "entity_meta_summary": None,
            "entity_relationships": [],
            "entity_meta__fields": ["entity_meta_summary"],
            "entity_id__fields": ["uuid"],
            "entity_changelog": [],
            "entity_data": {},
            "uuid": "aaef48d3-98f4-4e66-ade8-af0409137e2f",
        },
        "enqueued_documents_data": None,
        "enqueued_emails_data": None,
        "enqueued_subjects_data": None,
        "related_contacts": [],
        "progress_status": 0.5,
        "case_type_phase": "Afhandelen",
        "unaccepted_files_count": 0,
        "unaccepted_attribute_update_count": 0,
        "related_uuids": "",
        "parent_uuid": None,
        "child_uuids": "",
        "destructable": 0,
        "type_of_archiving": None,
        "period_of_preservation": None,
        "suspension_rationale": None,
        "result_description": None,
        "result_explanation": None,
        "result_selection_list_number": None,
        "result_process_type_number": None,
        "result_process_type_name": None,
        "result_process_type_description": None,
        "result_process_type_explanation": None,
        "result_process_type_object": None,
        "result_process_type_generic": None,
        "result_origin": None,
        "result_process_term": None,
        "active_selection_list": None,
        "aggregation_scope": "Dossier",
        "number_parent": None,
        "number_master": 2,
        "number_previous": None,
        "premature_completion_rationale": None,
        "case_location": "Ellermanstraat 23, 1114AK Amsterdam-Duivendrecht",
        "start_date": None,
        "price": "-",
        "lead_time_real": None,
        "progress_days": 0,
        "related_cases": "",
        "days_left": None,
        "number_relations": None,
        "relations": "",
        "relations_complete": "Nee",
        "documents": "test_document.txt (original)",
        "case_documents": "test_document.txt (original)",
    }

    def _loader(case_uuid: UUID | None = None, event_service=None):
        # if case_uuid == None:
        if not case_uuid:
            case_uuid = uuid4()

        return entities.Case(
            **case_entity_json,
            _event_service=event_service,
            uuid=case_uuid,
            entity_id=case_uuid,
        )

    return _loader
